//-----------------------------------------------------------
//  Label class -- Header
//
//  2016/03/28, Copyright (c) 2016 MIKAMI, Naoki
//-----------------------------------------------------------

#ifndef F746_LABEL_HPP
#define F746_LABEL_HPP

#include "GuiBase.hpp"

namespace Mikami
{
    class Label : public GuiBase
    {
    public:
        enum TextAlignMode { LEFT, CENTER };
        // Constructor
        Label(uint16_t x, uint16_t y, const string str,
              TextAlignMode mode = LEFT,
              sFONT &fonts = Font12,
              uint32_t textColor = GuiBase::ENUM_TEXT,
              uint32_t backColor = GuiBase::ENUM_BACK);

        void Draw(const string str);

    private:
        const TextAlignMode MODE_;

        uint8_t length_;

        uint16_t PosX(uint16_t x)
        {   return (MODE_ == LEFT) ?
                   x : x - length_*FONTS_->Width/2; }

        // disallow copy constructor and assignment operator
        Label(const Label&);
        Label& operator=(const Label&);
    };
}
#endif  // F746_LABEL_HPP
